/**
 * STAMP API
 * Neopost STAMP API. This API provides Shipping Tracking Accounting and Mailing functionalities.
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH }                                         from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class AddressApi {
    protected basePath = 'https://api-dev.neopost.com/stamp/v1';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * 
     * Extends object by coping non-existing properties.
     * @param objA object to be extended
     * @param objB source object
     */
    private extendObj<T1,T2>(objA: T1, objB: T2) {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                (objA as any)[key] = (objB as any)[key];
            }
        }
        return <T1&T2>objA;
    }

    /**
     * Export all addresses of an address book
     * 
     * @param aBookID 
     * @param length 
     * @param start 
     * @param orderBy 
     */
    public _export(aBookID?: string, length?: number, start?: number, orderBy?: Array<string>, extraHttpRequestParams?: any): Observable<models.AddressList> {
        return this._exportWithHttpInfo(aBookID, length, start, orderBy, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Add address to an existing address group
     * 
     * @param aID Address ID (id)
     * @param agCode Address Group Code
     * @param aBookID Address Book ID (UKey)
     */
    public addToGroup(aID: string, agCode: string, aBookID?: string, extraHttpRequestParams?: any): Observable<models.Address> {
        return this.addToGroupWithHttpInfo(aID, agCode, aBookID, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get details of an address
     * 
     * @param aID Address ID (id)
     * @param aBookID Address Book ID (UKey)
     */
    public address(aID: string, aBookID?: string, extraHttpRequestParams?: any): Observable<models.Address> {
        return this.addressWithHttpInfo(aID, aBookID, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * List of available countries
     * 
     */
    public countries(extraHttpRequestParams?: any): Observable<models.Country> {
        return this.countriesWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Detail of country
     * 
     * @param code Country code
     */
    public country(code?: string, extraHttpRequestParams?: any): Observable<models.Country> {
        return this.countryWithHttpInfo(code, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Create a new address
     * 
     * @param address address data
     * @param aBookID Address Book ID (UKey)
     */
    public createAddress(address?: models.Address, aBookID?: string, extraHttpRequestParams?: any): Observable<models.Address> {
        return this.createAddressWithHttpInfo(address, aBookID, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Create a new address group
     * 
     * @param aBookID 
     * @param body 
     */
    public createAddressGroup(aBookID?: string, body?: models.AddressGroup, extraHttpRequestParams?: any): Observable<models.AddressGroup> {
        return this.createAddressGroupWithHttpInfo(aBookID, body, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Delete an address
     * 
     * @param aID Address ID (id)
     * @param aBookID Address Book ID (UKey)
     */
    public deleteAddress(aID: string, aBookID?: string, extraHttpRequestParams?: any): Observable<string> {
        return this.deleteAddressWithHttpInfo(aID, aBookID, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Delete an address group
     * 
     * @param code Address Group code
     * @param aBookID 
     */
    public deleteAddressGroup(code: string, aBookID?: string, extraHttpRequestParams?: any): Observable<string> {
        return this.deleteAddressGroupWithHttpInfo(code, aBookID, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get an address group
     * 
     * @param code Address Group code
     * @param aBookID 
     */
    public get(code: string, aBookID?: string, extraHttpRequestParams?: any): Observable<models.AddressGroup> {
        return this.getWithHttpInfo(code, aBookID, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Import a previously uploaded file into an address book
     * 
     * @param aBookID 
     * @param body 
     */
    public importCsv(aBookID?: string, body?: models.CsvImportRequest, extraHttpRequestParams?: any): Observable<models.CsvImportStatus> {
        return this.importCsvWithHttpInfo(aBookID, body, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * List all address group
     * 
     * @param aBookID Address Book ID (UKey)
     * @param code Address Group code
     * @param owner Address Group owner
     * @param visibility Address Group visibility
     * @param length 
     * @param start 
     * @param orderBy 
     * @param orderAsc 
     */
    public list(aBookID: string, code?: string, owner?: string, visibility?: string, length?: number, start?: number, orderBy?: Array<string>, orderAsc?: boolean, extraHttpRequestParams?: any): Observable<models.AddressGroup> {
        return this.listWithHttpInfo(aBookID, code, owner, visibility, length, start, orderBy, orderAsc, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Remove address from an existing address group
     * 
     * @param aID Address ID (id)
     * @param agCode Address Group Code
     * @param aBookID Address Book ID (UKey)
     */
    public removeFromGroup(aID: string, agCode: string, aBookID?: string, extraHttpRequestParams?: any): Observable<models.Address> {
        return this.removeFromGroupWithHttpInfo(aID, agCode, aBookID, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Search addresses of an address book
     * 
     * @param body 
     * @param aBookID 
     * @param length 
     * @param start 
     * @param orderBy 
     * @param orderAsc 
     */
    public searchAddress(body?: models.Address, aBookID?: string, length?: number, start?: number, orderBy?: Array<string>, orderAsc?: boolean, extraHttpRequestParams?: any): Observable<models.AddressList> {
        return this.searchAddressWithHttpInfo(body, aBookID, length, start, orderBy, orderAsc, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get all addresses of an address book (and full text search)
     * 
     * @param aBookID 
     * @param length 
     * @param start 
     * @param orderBy 
     * @param q Full text search query
     */
    public searchAll(aBookID?: string, length?: number, start?: number, orderBy?: Array<string>, q?: string, extraHttpRequestParams?: any): Observable<models.AddressList> {
        return this.searchAllWithHttpInfo(aBookID, length, start, orderBy, q, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Update an address
     * 
     * @param aID Address ID (id)
     * @param address updated address data (null values won&#39;t be replaced)
     * @param aBookID Address Book ID (UKey)
     */
    public updateAddress(aID: string, address?: models.Address, aBookID?: string, extraHttpRequestParams?: any): Observable<models.Address> {
        return this.updateAddressWithHttpInfo(aID, address, aBookID, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Update an existing address group (code cannot be changed)
     * 
     * @param code Address Group code
     * @param aBookID 
     * @param body 
     */
    public updateAddressGroup(code: string, aBookID?: string, body?: models.AddressGroup, extraHttpRequestParams?: any): Observable<models.AddressGroup> {
        return this.updateAddressGroupWithHttpInfo(code, aBookID, body, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Upload file to be imported into an address book
     * 
     * @param aBookID 
     * @param fileName Name of File being uploaded
     * @param hasHeaderRow Is first line an header row?
     * @param file 
     */
    public uploadCsv(aBookID?: string, fileName?: string, hasHeaderRow?: boolean, file?: any, extraHttpRequestParams?: any): Observable<models.CsvImportOverview> {
        return this.uploadCsvWithHttpInfo(aBookID, fileName, hasHeaderRow, file, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Update last-used attribute of the address
     * 
     * @param aID Address ID (id)
     * @param aBookID Address Book ID (UKey)
     */
    public use(aID: string, aBookID?: string, extraHttpRequestParams?: any): Observable<models.Address> {
        return this.useWithHttpInfo(aID, aBookID, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Validate an address
     * 
     * @param address Address data
     * @param validator Validator
     */
    public validateAddress(address?: models.Address, validator?: string, extraHttpRequestParams?: any): Observable<models.Address> {
        return this.validateAddressWithHttpInfo(address, validator, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Validate all addresses accross all address book (max 100)
     * 
     */
    public validateAll(extraHttpRequestParams?: any): Observable<models.AddressValidationAllResponse> {
        return this.validateAllWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * Export all addresses of an address book
     * 
     * @param aBookID 
     * @param length 
     * @param start 
     * @param orderBy 
     */
    public _exportWithHttpInfo(aBookID?: string, length?: number, start?: number, orderBy?: Array<string>, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/export/csv`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }
        if (length !== undefined) {
            queryParameters.set('length', <any>length);
        }
        if (start !== undefined) {
            queryParameters.set('start', <any>start);
        }
        if (orderBy !== undefined) {
            queryParameters.set('orderBy', <any>orderBy);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'text/csv'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Add address to an existing address group
     * 
     * @param aID Address ID (id)
     * @param agCode Address Group Code
     * @param aBookID Address Book ID (UKey)
     */
    public addToGroupWithHttpInfo(aID: string, agCode: string, aBookID?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/${aID}/group/${agCode}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'aID' is not null or undefined
        if (aID === null || aID === undefined) {
            throw new Error('Required parameter aID was null or undefined when calling addToGroup.');
        }
        // verify required parameter 'agCode' is not null or undefined
        if (agCode === null || agCode === undefined) {
            throw new Error('Required parameter agCode was null or undefined when calling addToGroup.');
        }
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get details of an address
     * 
     * @param aID Address ID (id)
     * @param aBookID Address Book ID (UKey)
     */
    public addressWithHttpInfo(aID: string, aBookID?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/${aID}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'aID' is not null or undefined
        if (aID === null || aID === undefined) {
            throw new Error('Required parameter aID was null or undefined when calling address.');
        }
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * List of available countries
     * 
     */
    public countriesWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/validate/countries`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Detail of country
     * 
     * @param code Country code
     */
    public countryWithHttpInfo(code?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/validate/country`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (code !== undefined) {
            queryParameters.set('code', <any>code);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Create a new address
     * 
     * @param address address data
     * @param aBookID Address Book ID (UKey)
     */
    public createAddressWithHttpInfo(address?: models.Address, aBookID?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: address == null ? '' : JSON.stringify(address), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Create a new address group
     * 
     * @param aBookID 
     * @param body 
     */
    public createAddressGroupWithHttpInfo(aBookID?: string, body?: models.AddressGroup, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/group`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: body == null ? '' : JSON.stringify(body), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Delete an address
     * 
     * @param aID Address ID (id)
     * @param aBookID Address Book ID (UKey)
     */
    public deleteAddressWithHttpInfo(aID: string, aBookID?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/${aID}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'aID' is not null or undefined
        if (aID === null || aID === undefined) {
            throw new Error('Required parameter aID was null or undefined when calling deleteAddress.');
        }
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Delete an address group
     * 
     * @param code Address Group code
     * @param aBookID 
     */
    public deleteAddressGroupWithHttpInfo(code: string, aBookID?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/group/${code}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'code' is not null or undefined
        if (code === null || code === undefined) {
            throw new Error('Required parameter code was null or undefined when calling deleteAddressGroup.');
        }
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get an address group
     * 
     * @param code Address Group code
     * @param aBookID 
     */
    public getWithHttpInfo(code: string, aBookID?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/group/${code}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'code' is not null or undefined
        if (code === null || code === undefined) {
            throw new Error('Required parameter code was null or undefined when calling get.');
        }
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Import a previously uploaded file into an address book
     * 
     * @param aBookID 
     * @param body 
     */
    public importCsvWithHttpInfo(aBookID?: string, body?: models.CsvImportRequest, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/import`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: body == null ? '' : JSON.stringify(body), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * List all address group
     * 
     * @param aBookID Address Book ID (UKey)
     * @param code Address Group code
     * @param owner Address Group owner
     * @param visibility Address Group visibility
     * @param length 
     * @param start 
     * @param orderBy 
     * @param orderAsc 
     */
    public listWithHttpInfo(aBookID: string, code?: string, owner?: string, visibility?: string, length?: number, start?: number, orderBy?: Array<string>, orderAsc?: boolean, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/group`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'aBookID' is not null or undefined
        if (aBookID === null || aBookID === undefined) {
            throw new Error('Required parameter aBookID was null or undefined when calling list.');
        }
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }
        if (code !== undefined) {
            queryParameters.set('code', <any>code);
        }
        if (owner !== undefined) {
            queryParameters.set('owner', <any>owner);
        }
        if (visibility !== undefined) {
            queryParameters.set('visibility', <any>visibility);
        }
        if (length !== undefined) {
            queryParameters.set('length', <any>length);
        }
        if (start !== undefined) {
            queryParameters.set('start', <any>start);
        }
        if (orderBy !== undefined) {
            queryParameters.set('orderBy', <any>orderBy);
        }
        if (orderAsc !== undefined) {
            queryParameters.set('orderAsc', <any>orderAsc);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Remove address from an existing address group
     * 
     * @param aID Address ID (id)
     * @param agCode Address Group Code
     * @param aBookID Address Book ID (UKey)
     */
    public removeFromGroupWithHttpInfo(aID: string, agCode: string, aBookID?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/${aID}/group/${agCode}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'aID' is not null or undefined
        if (aID === null || aID === undefined) {
            throw new Error('Required parameter aID was null or undefined when calling removeFromGroup.');
        }
        // verify required parameter 'agCode' is not null or undefined
        if (agCode === null || agCode === undefined) {
            throw new Error('Required parameter agCode was null or undefined when calling removeFromGroup.');
        }
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Search addresses of an address book
     * 
     * @param body 
     * @param aBookID 
     * @param length 
     * @param start 
     * @param orderBy 
     * @param orderAsc 
     */
    public searchAddressWithHttpInfo(body?: models.Address, aBookID?: string, length?: number, start?: number, orderBy?: Array<string>, orderAsc?: boolean, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/search`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }
        if (length !== undefined) {
            queryParameters.set('length', <any>length);
        }
        if (start !== undefined) {
            queryParameters.set('start', <any>start);
        }
        if (orderBy !== undefined) {
            queryParameters.set('orderBy', <any>orderBy);
        }
        if (orderAsc !== undefined) {
            queryParameters.set('orderAsc', <any>orderAsc);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: body == null ? '' : JSON.stringify(body), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get all addresses of an address book (and full text search)
     * 
     * @param aBookID 
     * @param length 
     * @param start 
     * @param orderBy 
     * @param q Full text search query
     */
    public searchAllWithHttpInfo(aBookID?: string, length?: number, start?: number, orderBy?: Array<string>, q?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }
        if (length !== undefined) {
            queryParameters.set('length', <any>length);
        }
        if (start !== undefined) {
            queryParameters.set('start', <any>start);
        }
        if (orderBy !== undefined) {
            queryParameters.set('orderBy', <any>orderBy);
        }
        if (q !== undefined) {
            queryParameters.set('q', <any>q);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Update an address
     * 
     * @param aID Address ID (id)
     * @param address updated address data (null values won&#39;t be replaced)
     * @param aBookID Address Book ID (UKey)
     */
    public updateAddressWithHttpInfo(aID: string, address?: models.Address, aBookID?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/${aID}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'aID' is not null or undefined
        if (aID === null || aID === undefined) {
            throw new Error('Required parameter aID was null or undefined when calling updateAddress.');
        }
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: address == null ? '' : JSON.stringify(address), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Update an existing address group (code cannot be changed)
     * 
     * @param code Address Group code
     * @param aBookID 
     * @param body 
     */
    public updateAddressGroupWithHttpInfo(code: string, aBookID?: string, body?: models.AddressGroup, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/group/${code}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'code' is not null or undefined
        if (code === null || code === undefined) {
            throw new Error('Required parameter code was null or undefined when calling updateAddressGroup.');
        }
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: body == null ? '' : JSON.stringify(body), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Upload file to be imported into an address book
     * 
     * @param aBookID 
     * @param fileName Name of File being uploaded
     * @param hasHeaderRow Is first line an header row?
     * @param file 
     */
    public uploadCsvWithHttpInfo(aBookID?: string, fileName?: string, hasHeaderRow?: boolean, file?: any, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/import/upload`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }
        if (fileName !== undefined) {
            queryParameters.set('fileName', <any>fileName);
        }
        if (hasHeaderRow !== undefined) {
            queryParameters.set('has_header_row', <any>hasHeaderRow);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/octet-stream'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            
        headers.set('Content-Type', 'application/x-www-form-urlencoded');


        if (file !== undefined) {
            formParams.set('file', <any>file); 
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Update last-used attribute of the address
     * 
     * @param aID Address ID (id)
     * @param aBookID Address Book ID (UKey)
     */
    public useWithHttpInfo(aID: string, aBookID?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/${aID}/use`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'aID' is not null or undefined
        if (aID === null || aID === undefined) {
            throw new Error('Required parameter aID was null or undefined when calling use.');
        }
        if (aBookID !== undefined) {
            queryParameters.set('aBookID', <any>aBookID);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Validate an address
     * 
     * @param address Address data
     * @param validator Validator
     */
    public validateAddressWithHttpInfo(address?: models.Address, validator?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/validate`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (validator !== undefined) {
            queryParameters.set('validator', <any>validator);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: address == null ? '' : JSON.stringify(address), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Validate all addresses accross all address book (max 100)
     * 
     */
    public validateAllWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/address/validate/all`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
