/**
 * STAMP API
 * Neopost STAMP API. This API provides Shipping Tracking Accounting and Mailing functionalities.
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH }                                         from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class CarrierAccountApi {
    protected basePath = 'https://api-dev.neopost.com/stamp/v1';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * 
     * Extends object by coping non-existing properties.
     * @param objA object to be extended
     * @param objB source object
     */
    private extendObj<T1,T2>(objA: T1, objB: T2) {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                (objA as any)[key] = (objB as any)[key];
            }
        }
        return <T1&T2>objA;
    }

    /**
     * Add a new carrier account configuration
     * 
     * @param account object account
     * @param validate validate
     */
    public addCarrierAccount(account object: models.CarrierAccount, validate?: string, extraHttpRequestParams?: any): Observable<models.CarrierAccount> {
        return this.addCarrierAccountWithHttpInfo(account object, validate, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Delete a carrier account configuration
     * 
     * @param accountID account id to be deleted
     */
    public deleteCarrierAccount(accountID: string, extraHttpRequestParams?: any): Observable<models.Status> {
        return this.deleteCarrierAccountWithHttpInfo(accountID, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get a carrier account configuration
     * 
     * @param accountID account id to be get
     */
    public getCarrierAccount(accountID: string, extraHttpRequestParams?: any): Observable<models.CarrierAccount> {
        return this.getCarrierAccountWithHttpInfo(accountID, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get license agreement
     * 
     * @param carrier carrier
     */
    public getLicenseAgreement(carrier: string, extraHttpRequestParams?: any): Observable<models.LicenseAgreementResponse> {
        return this.getLicenseAgreementWithHttpInfo(carrier, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get list of carrier account configurations
     * 
     * @param carrierCode Carrier code
     * @param length Max number of records to return
     * @param start First record to start
     * @param orderBy name of field to sort by
     * @param orderAsc Ascending order or Descending order
     */
    public getListCarrierAccountNamespace(carrierCode?: string, length?: number, start?: number, orderBy?: Array<string>, orderAsc?: boolean, extraHttpRequestParams?: any): Observable<{}> {
        return this.getListCarrierAccountNamespaceWithHttpInfo(carrierCode, length, start, orderBy, orderAsc, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Pickup request
     * 
     * @param accountId Account ID
     */
    public pickupRequest(accountId: string, extraHttpRequestParams?: any): Observable<models.ShipmentRateResponse> {
        return this.pickupRequestWithHttpInfo(accountId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Commission a carrier account
     * 
     * @param storeAccount Store the newly commissioned account as default
     * @param shipperAlias Shipper alias. if provided, the account will be defined as default for this shipper
     * @param body 
     */
    public registerCarrierAccount(storeAccount: boolean, shipperAlias?: string, body?: models.CarrierAccountRegistrationRequest, extraHttpRequestParams?: any): Observable<models.CarrierAccount> {
        return this.registerCarrierAccountWithHttpInfo(storeAccount, shipperAlias, body, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Update a carrier account configurations
     * 
     * @param account object account
     * @param accountID account id to be get
     * @param validate validate
     */
    public updateCarrierAccount(account object: models.CarrierAccount, accountID: string, validate?: string, extraHttpRequestParams?: any): Observable<models.Status> {
        return this.updateCarrierAccountWithHttpInfo(account object, accountID, validate, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * Add a new carrier account configuration
     * 
     * @param account object account
     * @param validate validate
     */
    public addCarrierAccountWithHttpInfo(account object: models.CarrierAccount, validate?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/carrieraccount`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'account object' is not null or undefined
        if (account object === null || account object === undefined) {
            throw new Error('Required parameter account object was null or undefined when calling addCarrierAccount.');
        }
        if (validate !== undefined) {
            queryParameters.set('validate', <any>validate);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: account object == null ? '' : JSON.stringify(account object), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Delete a carrier account configuration
     * 
     * @param accountID account id to be deleted
     */
    public deleteCarrierAccountWithHttpInfo(accountID: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/carrieraccount/${accountID}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'accountID' is not null or undefined
        if (accountID === null || accountID === undefined) {
            throw new Error('Required parameter accountID was null or undefined when calling deleteCarrierAccount.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get a carrier account configuration
     * 
     * @param accountID account id to be get
     */
    public getCarrierAccountWithHttpInfo(accountID: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/carrieraccount/${accountID}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'accountID' is not null or undefined
        if (accountID === null || accountID === undefined) {
            throw new Error('Required parameter accountID was null or undefined when calling getCarrierAccount.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get license agreement
     * 
     * @param carrier carrier
     */
    public getLicenseAgreementWithHttpInfo(carrier: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/carrieraccount/license`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'carrier' is not null or undefined
        if (carrier === null || carrier === undefined) {
            throw new Error('Required parameter carrier was null or undefined when calling getLicenseAgreement.');
        }
        if (carrier !== undefined) {
            queryParameters.set('carrier', <any>carrier);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get list of carrier account configurations
     * 
     * @param carrierCode Carrier code
     * @param length Max number of records to return
     * @param start First record to start
     * @param orderBy name of field to sort by
     * @param orderAsc Ascending order or Descending order
     */
    public getListCarrierAccountNamespaceWithHttpInfo(carrierCode?: string, length?: number, start?: number, orderBy?: Array<string>, orderAsc?: boolean, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/carrieraccount`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (carrierCode !== undefined) {
            queryParameters.set('carrier_code', <any>carrierCode);
        }
        if (length !== undefined) {
            queryParameters.set('length', <any>length);
        }
        if (start !== undefined) {
            queryParameters.set('start', <any>start);
        }
        if (orderBy !== undefined) {
            queryParameters.set('orderBy', <any>orderBy);
        }
        if (orderAsc !== undefined) {
            queryParameters.set('orderAsc', <any>orderAsc);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Pickup request
     * 
     * @param accountId Account ID
     */
    public pickupRequestWithHttpInfo(accountId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/carrieraccount/${accountId}/pickup/request`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'accountId' is not null or undefined
        if (accountId === null || accountId === undefined) {
            throw new Error('Required parameter accountId was null or undefined when calling pickupRequest.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Commission a carrier account
     * 
     * @param storeAccount Store the newly commissioned account as default
     * @param shipperAlias Shipper alias. if provided, the account will be defined as default for this shipper
     * @param body 
     */
    public registerCarrierAccountWithHttpInfo(storeAccount: boolean, shipperAlias?: string, body?: models.CarrierAccountRegistrationRequest, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/carrieraccount/commission`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'storeAccount' is not null or undefined
        if (storeAccount === null || storeAccount === undefined) {
            throw new Error('Required parameter storeAccount was null or undefined when calling registerCarrierAccount.');
        }
        if (storeAccount !== undefined) {
            queryParameters.set('store_account', <any>storeAccount);
        }
        if (shipperAlias !== undefined) {
            queryParameters.set('shipper_alias', <any>shipperAlias);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: body == null ? '' : JSON.stringify(body), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Update a carrier account configurations
     * 
     * @param account object account
     * @param accountID account id to be get
     * @param validate validate
     */
    public updateCarrierAccountWithHttpInfo(account object: models.CarrierAccount, accountID: string, validate?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/carrieraccount/${accountID}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'account object' is not null or undefined
        if (account object === null || account object === undefined) {
            throw new Error('Required parameter account object was null or undefined when calling updateCarrierAccount.');
        }
        // verify required parameter 'accountID' is not null or undefined
        if (accountID === null || accountID === undefined) {
            throw new Error('Required parameter accountID was null or undefined when calling updateCarrierAccount.');
        }
        if (validate !== undefined) {
            queryParameters.set('validate', <any>validate);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: account object == null ? '' : JSON.stringify(account object), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
