/**
 * STAMP API
 * Neopost STAMP API. This API provides Shipping Tracking Accounting and Mailing functionalities.
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH }                                         from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class CostCenterApi {
    protected basePath = 'https://api-dev.neopost.com/stamp/v1';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * 
     * Extends object by coping non-existing properties.
     * @param objA object to be extended
     * @param objB source object
     */
    private extendObj<T1,T2>(objA: T1, objB: T2) {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                (objA as any)[key] = (objB as any)[key];
            }
        }
        return <T1&T2>objA;
    }

    /**
     * Add a new cost center configuration
     * 
     * @param costCenter cost center object
     */
    public addCostCenter(costCenter: models.CostCenter, extraHttpRequestParams?: any): Observable<{}> {
        return this.addCostCenterWithHttpInfo(costCenter, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Add a new value configuration
     * 
     * @param value object value
     */
    public addValue(value object: models.Value, extraHttpRequestParams?: any): Observable<{}> {
        return this.addValueWithHttpInfo(value object, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Delete a cost center configuration
     * 
     * @param costCenterId cost center id to be deleted
     */
    public deleteCostCenter(costCenterId: string, extraHttpRequestParams?: any): Observable<models.Status> {
        return this.deleteCostCenterWithHttpInfo(costCenterId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Delete a value configuration
     * 
     * @param valueId value id to be deleted
     */
    public deleteValue(valueId: string, extraHttpRequestParams?: any): Observable<models.Status> {
        return this.deleteValueWithHttpInfo(valueId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Delete a value configuration
     * 
     * @param dimension dimension to be deleted
     */
    public deleteValueFromDimension(dimension: string, extraHttpRequestParams?: any): Observable<models.Status> {
        return this.deleteValueFromDimensionWithHttpInfo(dimension, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get a cost center configuration
     * 
     * @param code cost center code
     */
    public getCostCenter(code: string, extraHttpRequestParams?: any): Observable<models.CostCenterResponse> {
        return this.getCostCenterWithHttpInfo(code, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get a cost center configuration
     * 
     * @param costCenterId Cost center to be get
     */
    public getCostCenterById(costCenterId: string, extraHttpRequestParams?: any): Observable<models.CostCenterResponse> {
        return this.getCostCenterByIdWithHttpInfo(costCenterId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get list of values
     * 
     */
    public getListValue(extraHttpRequestParams?: any): Observable<models.ValueList> {
        return this.getListValueWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get list of values by code
     * 
     * @param text Search by text
     * @param code Search by code
     * @param dimension The dimension
     * @param parent The parent
     * @param isActive only active
     */
    public getListValueByCode(text?: string, code?: string, dimension?: string, parent?: string, isActive?: boolean, extraHttpRequestParams?: any): Observable<models.ValueList> {
        return this.getListValueByCodeWithHttpInfo(text, code, dimension, parent, isActive, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get a value configuration
     * 
     * @param valueId value id to be get
     */
    public getValue(valueId: string, extraHttpRequestParams?: any): Observable<models.Value> {
        return this.getValueWithHttpInfo(valueId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Search cost center
     * 
     * @param length Max number of records to return
     * @param start First record to start
     * @param orderBy name of field to sort by
     * @param orderAsc Ascending order or Descending order
     * @param text Text search
     */
    public searchCostCenter(length?: number, start?: number, orderBy?: Array<string>, orderAsc?: boolean, text?: string, extraHttpRequestParams?: any): Observable<models.CostCenterResponseList> {
        return this.searchCostCenterWithHttpInfo(length, start, orderBy, orderAsc, text, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Update a cost center configuration
     * 
     * @param costCenterId cost center id to be updated
     * @param costCenter cost center object
     */
    public updateCostCenter(costCenterId: string, costCenter: models.CostCenter, extraHttpRequestParams?: any): Observable<{}> {
        return this.updateCostCenterWithHttpInfo(costCenterId, costCenter, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * update a value configuration
     * 
     * @param value object value
     * @param valueId value id to be get
     */
    public updateValue(value object: models.Value, valueId: string, extraHttpRequestParams?: any): Observable<models.Status> {
        return this.updateValueWithHttpInfo(value object, valueId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Import value from a CSV file
     * 
     * @param dimension dimension
     * @param file file to upload
     */
    public uploadFileCSV(dimension: string, file?: any, extraHttpRequestParams?: any): Observable<{}> {
        return this.uploadFileCSVWithHttpInfo(dimension, file, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * Add a new cost center configuration
     * 
     * @param costCenter cost center object
     */
    public addCostCenterWithHttpInfo(costCenter: models.CostCenter, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/costcenter`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'costCenter' is not null or undefined
        if (costCenter === null || costCenter === undefined) {
            throw new Error('Required parameter costCenter was null or undefined when calling addCostCenter.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: costCenter == null ? '' : JSON.stringify(costCenter), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Add a new value configuration
     * 
     * @param value object value
     */
    public addValueWithHttpInfo(value object: models.Value, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/costcenter/value`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'value object' is not null or undefined
        if (value object === null || value object === undefined) {
            throw new Error('Required parameter value object was null or undefined when calling addValue.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: value object == null ? '' : JSON.stringify(value object), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Delete a cost center configuration
     * 
     * @param costCenterId cost center id to be deleted
     */
    public deleteCostCenterWithHttpInfo(costCenterId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/costcenter/${costCenterId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'costCenterId' is not null or undefined
        if (costCenterId === null || costCenterId === undefined) {
            throw new Error('Required parameter costCenterId was null or undefined when calling deleteCostCenter.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Delete a value configuration
     * 
     * @param valueId value id to be deleted
     */
    public deleteValueWithHttpInfo(valueId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/costcenter/value/${valueId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'valueId' is not null or undefined
        if (valueId === null || valueId === undefined) {
            throw new Error('Required parameter valueId was null or undefined when calling deleteValue.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Delete a value configuration
     * 
     * @param dimension dimension to be deleted
     */
    public deleteValueFromDimensionWithHttpInfo(dimension: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/costcenter/value/deleteFromDimension`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'dimension' is not null or undefined
        if (dimension === null || dimension === undefined) {
            throw new Error('Required parameter dimension was null or undefined when calling deleteValueFromDimension.');
        }
        if (dimension !== undefined) {
            queryParameters.set('dimension', <any>dimension);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get a cost center configuration
     * 
     * @param code cost center code
     */
    public getCostCenterWithHttpInfo(code: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/costcenter`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'code' is not null or undefined
        if (code === null || code === undefined) {
            throw new Error('Required parameter code was null or undefined when calling getCostCenter.');
        }
        if (code !== undefined) {
            queryParameters.set('code', <any>code);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get a cost center configuration
     * 
     * @param costCenterId Cost center to be get
     */
    public getCostCenterByIdWithHttpInfo(costCenterId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/costcenter/${costCenterId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'costCenterId' is not null or undefined
        if (costCenterId === null || costCenterId === undefined) {
            throw new Error('Required parameter costCenterId was null or undefined when calling getCostCenterById.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get list of values
     * 
     */
    public getListValueWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/costcenter/value`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get list of values by code
     * 
     * @param text Search by text
     * @param code Search by code
     * @param dimension The dimension
     * @param parent The parent
     * @param isActive only active
     */
    public getListValueByCodeWithHttpInfo(text?: string, code?: string, dimension?: string, parent?: string, isActive?: boolean, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/costcenter/value/search`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (text !== undefined) {
            queryParameters.set('text', <any>text);
        }
        if (code !== undefined) {
            queryParameters.set('code', <any>code);
        }
        if (dimension !== undefined) {
            queryParameters.set('dimension', <any>dimension);
        }
        if (parent !== undefined) {
            queryParameters.set('parent', <any>parent);
        }
        if (isActive !== undefined) {
            queryParameters.set('isActive', <any>isActive);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get a value configuration
     * 
     * @param valueId value id to be get
     */
    public getValueWithHttpInfo(valueId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/costcenter/value/${valueId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'valueId' is not null or undefined
        if (valueId === null || valueId === undefined) {
            throw new Error('Required parameter valueId was null or undefined when calling getValue.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Search cost center
     * 
     * @param length Max number of records to return
     * @param start First record to start
     * @param orderBy name of field to sort by
     * @param orderAsc Ascending order or Descending order
     * @param text Text search
     */
    public searchCostCenterWithHttpInfo(length?: number, start?: number, orderBy?: Array<string>, orderAsc?: boolean, text?: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/costcenter/search`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (length !== undefined) {
            queryParameters.set('length', <any>length);
        }
        if (start !== undefined) {
            queryParameters.set('start', <any>start);
        }
        if (orderBy !== undefined) {
            queryParameters.set('orderBy', <any>orderBy);
        }
        if (orderAsc !== undefined) {
            queryParameters.set('orderAsc', <any>orderAsc);
        }
        if (text !== undefined) {
            queryParameters.set('text', <any>text);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Update a cost center configuration
     * 
     * @param costCenterId cost center id to be updated
     * @param costCenter cost center object
     */
    public updateCostCenterWithHttpInfo(costCenterId: string, costCenter: models.CostCenter, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/costcenter/${costCenterId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'costCenterId' is not null or undefined
        if (costCenterId === null || costCenterId === undefined) {
            throw new Error('Required parameter costCenterId was null or undefined when calling updateCostCenter.');
        }
        // verify required parameter 'costCenter' is not null or undefined
        if (costCenter === null || costCenter === undefined) {
            throw new Error('Required parameter costCenter was null or undefined when calling updateCostCenter.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: costCenter == null ? '' : JSON.stringify(costCenter), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * update a value configuration
     * 
     * @param value object value
     * @param valueId value id to be get
     */
    public updateValueWithHttpInfo(value object: models.Value, valueId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/costcenter/value/${valueId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'value object' is not null or undefined
        if (value object === null || value object === undefined) {
            throw new Error('Required parameter value object was null or undefined when calling updateValue.');
        }
        // verify required parameter 'valueId' is not null or undefined
        if (valueId === null || valueId === undefined) {
            throw new Error('Required parameter valueId was null or undefined when calling updateValue.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: value object == null ? '' : JSON.stringify(value object), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Import value from a CSV file
     * 
     * @param dimension dimension
     * @param file file to upload
     */
    public uploadFileCSVWithHttpInfo(dimension: string, file?: any, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/costcenter/value/import`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'dimension' is not null or undefined
        if (dimension === null || dimension === undefined) {
            throw new Error('Required parameter dimension was null or undefined when calling uploadFileCSV.');
        }
        if (dimension !== undefined) {
            queryParameters.set('dimension', <any>dimension);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'multipart/form-data'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json; charset=UTF-8'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            
        headers.set('Content-Type', 'application/x-www-form-urlencoded');


        if (file !== undefined) {
            formParams.set('file', <any>file); 
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
