/**
 * STAMP API
 * Neopost STAMP API. This API provides Shipping Tracking Accounting and Mailing functionalities.
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH }                                         from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class CustomPackagingApi {
    protected basePath = 'https://api-dev.neopost.com/stamp/v1';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * 
     * Extends object by coping non-existing properties.
     * @param objA object to be extended
     * @param objB source object
     */
    private extendObj<T1,T2>(objA: T1, objB: T2) {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                (objA as any)[key] = (objB as any)[key];
            }
        }
        return <T1&T2>objA;
    }

    /**
     * Add a new custom packaging
     * 
     * @param packaging object packaging
     */
    public addCustomPackaging(packaging object: models.CustomPackaging, extraHttpRequestParams?: any): Observable<models.CustomPackagingResponse> {
        return this.addCustomPackagingWithHttpInfo(packaging object, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Delete a custom packaging
     * 
     * @param packagingId packaging id to be deleted
     */
    public deleteCustomPackaging(packagingId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.deleteCustomPackagingWithHttpInfo(packagingId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get a custom packaging
     * 
     * @param packagingId custom packaging id to be get
     */
    public getCustomPackaging(packagingId: string, extraHttpRequestParams?: any): Observable<models.CustomPackagingResponse> {
        return this.getCustomPackagingWithHttpInfo(packagingId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get a custom packaging&#39;s image
     * 
     * @param packagingId custom packaging id to be get
     */
    public getImagePackaging(packagingId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.getImagePackagingWithHttpInfo(packagingId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get list of custom packagings
     * 
     * @param length Max number of records to return
     * @param start First record to start
     * @param orderBy name of field to sort by
     * @param orderAsc Ascending order or Descending order
     */
    public getListCustomPackagingsNamespace(length?: number, start?: number, orderBy?: Array<string>, orderAsc?: boolean, extraHttpRequestParams?: any): Observable<models.ListCustomPackaging> {
        return this.getListCustomPackagingsNamespaceWithHttpInfo(length, start, orderBy, orderAsc, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * update a custom packaging
     * 
     * @param custom packaging object customPackaging
     * @param packagingId custom packaging id to be get
     */
    public updateCustomPackaging(custom packaging object: models.CustomPackaging, packagingId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.updateCustomPackagingWithHttpInfo(custom packaging object, packagingId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Upload image to packaging
     * 
     * @param packagingId packaging id
     * @param file file to upload
     */
    public uploadFile(packagingId: string, file?: any, extraHttpRequestParams?: any): Observable<{}> {
        return this.uploadFileWithHttpInfo(packagingId, file, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * Add a new custom packaging
     * 
     * @param packaging object packaging
     */
    public addCustomPackagingWithHttpInfo(packaging object: models.CustomPackaging, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/custompackaging`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'packaging object' is not null or undefined
        if (packaging object === null || packaging object === undefined) {
            throw new Error('Required parameter packaging object was null or undefined when calling addCustomPackaging.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: packaging object == null ? '' : JSON.stringify(packaging object), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Delete a custom packaging
     * 
     * @param packagingId packaging id to be deleted
     */
    public deleteCustomPackagingWithHttpInfo(packagingId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/custompackaging/${packagingId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'packagingId' is not null or undefined
        if (packagingId === null || packagingId === undefined) {
            throw new Error('Required parameter packagingId was null or undefined when calling deleteCustomPackaging.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get a custom packaging
     * 
     * @param packagingId custom packaging id to be get
     */
    public getCustomPackagingWithHttpInfo(packagingId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/custompackaging/${packagingId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'packagingId' is not null or undefined
        if (packagingId === null || packagingId === undefined) {
            throw new Error('Required parameter packagingId was null or undefined when calling getCustomPackaging.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get a custom packaging&#39;s image
     * 
     * @param packagingId custom packaging id to be get
     */
    public getImagePackagingWithHttpInfo(packagingId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/custompackaging/${packagingId}/img`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'packagingId' is not null or undefined
        if (packagingId === null || packagingId === undefined) {
            throw new Error('Required parameter packagingId was null or undefined when calling getImagePackaging.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'image/png', 
            'image/jpg'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get list of custom packagings
     * 
     * @param length Max number of records to return
     * @param start First record to start
     * @param orderBy name of field to sort by
     * @param orderAsc Ascending order or Descending order
     */
    public getListCustomPackagingsNamespaceWithHttpInfo(length?: number, start?: number, orderBy?: Array<string>, orderAsc?: boolean, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/custompackaging`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (length !== undefined) {
            queryParameters.set('length', <any>length);
        }
        if (start !== undefined) {
            queryParameters.set('start', <any>start);
        }
        if (orderBy !== undefined) {
            queryParameters.set('orderBy', <any>orderBy);
        }
        if (orderAsc !== undefined) {
            queryParameters.set('orderAsc', <any>orderAsc);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * update a custom packaging
     * 
     * @param custom packaging object customPackaging
     * @param packagingId custom packaging id to be get
     */
    public updateCustomPackagingWithHttpInfo(custom packaging object: models.CustomPackaging, packagingId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/custompackaging/${packagingId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'custom packaging object' is not null or undefined
        if (custom packaging object === null || custom packaging object === undefined) {
            throw new Error('Required parameter custom packaging object was null or undefined when calling updateCustomPackaging.');
        }
        // verify required parameter 'packagingId' is not null or undefined
        if (packagingId === null || packagingId === undefined) {
            throw new Error('Required parameter packagingId was null or undefined when calling updateCustomPackaging.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: custom packaging object == null ? '' : JSON.stringify(custom packaging object), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Upload image to packaging
     * 
     * @param packagingId packaging id
     * @param file file to upload
     */
    public uploadFileWithHttpInfo(packagingId: string, file?: any, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/custompackaging/${packagingId}/img`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // verify required parameter 'packagingId' is not null or undefined
        if (packagingId === null || packagingId === undefined) {
            throw new Error('Required parameter packagingId was null or undefined when calling uploadFile.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'multipart/form-data'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json; charset=UTF-8'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            
        headers.set('Content-Type', 'application/x-www-form-urlencoded');


        if (file !== undefined) {
            formParams.set('file', <any>file); 
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
