/**
 * STAMP API
 * Neopost STAMP API. This API provides Shipping Tracking Accounting and Mailing functionalities.
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH }                                         from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class HandlingChargeApi {
    protected basePath = 'https://api-dev.neopost.com/stamp/v1';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * 
     * Extends object by coping non-existing properties.
     * @param objA object to be extended
     * @param objB source object
     */
    private extendObj<T1,T2>(objA: T1, objB: T2) {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                (objA as any)[key] = (objB as any)[key];
            }
        }
        return <T1&T2>objA;
    }

    /**
     * Add a new handling charge configuration
     * 
     * @param handling charge object handling charge
     */
    public addHandlingCharge(handling charge object: models.HandlingCharge, extraHttpRequestParams?: any): Observable<models.HandlingCharge> {
        return this.addHandlingChargeWithHttpInfo(handling charge object, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Add a handling charge rule
     * 
     * @param body Handling Charge Rule
     */
    public addHandlingChargeRule(body: models.HandlingChargeRule, extraHttpRequestParams?: any): Observable<models.HandlingChargeRule> {
        return this.addHandlingChargeRuleWithHttpInfo(body, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * DELETE a handling charge config
     * 
     * @param configId handlingcharge_id
     */
    public deleteHandlingCharge(configId: string, extraHttpRequestParams?: any): Observable<models.Status> {
        return this.deleteHandlingChargeWithHttpInfo(configId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Delete a handling charge rule
     * 
     * @param ruleId Handling Charge ID
     */
    public deleteHandlingChargeRule(ruleId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.deleteHandlingChargeRuleWithHttpInfo(ruleId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get a handling charge config
     * 
     * @param configId handlingcharge_id
     */
    public getHandlingCharge(configId: string, extraHttpRequestParams?: any): Observable<models.HandlingCharge> {
        return this.getHandlingChargeWithHttpInfo(configId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Add a handling charge rule
     * 
     * @param ruleId Handling Charge ID
     */
    public getHandlingChargeRule(ruleId: string, extraHttpRequestParams?: any): Observable<models.HandlingChargeRule> {
        return this.getHandlingChargeRuleWithHttpInfo(ruleId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get a list of all handling charges
     * 
     * @param namespace 
     */
    public getListHandlingCharge(namespace: string, extraHttpRequestParams?: any): Observable<models.HandlingChargeList> {
        return this.getListHandlingChargeWithHttpInfo(namespace, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get a list of all handling charge rules
     * 
     * @param namespace 
     */
    public getListHandlingChargeRules(namespace: string, extraHttpRequestParams?: any): Observable<models.HandlingChargeRuleList> {
        return this.getListHandlingChargeRulesWithHttpInfo(namespace, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Add a new handling charge configuration
     * 
     * @param handling charge object handling charge
     * @param configId 
     */
    public updateHandlingCharge(handling charge object: models.HandlingCharge, configId: string, extraHttpRequestParams?: any): Observable<models.HandlingCharge> {
        return this.updateHandlingChargeWithHttpInfo(handling charge object, configId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Add a handling charge rule
     * 
     * @param ruleId Handling Charge ID
     * @param body Handling Charge Rule
     */
    public updateHandlingChargeRule(ruleId: string, body: models.HandlingChargeRule, extraHttpRequestParams?: any): Observable<models.HandlingChargeRule> {
        return this.updateHandlingChargeRuleWithHttpInfo(ruleId, body, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * Add a new handling charge configuration
     * 
     * @param handling charge object handling charge
     */
    public addHandlingChargeWithHttpInfo(handling charge object: models.HandlingCharge, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/handlingcharge/config`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'handling charge object' is not null or undefined
        if (handling charge object === null || handling charge object === undefined) {
            throw new Error('Required parameter handling charge object was null or undefined when calling addHandlingCharge.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: handling charge object == null ? '' : JSON.stringify(handling charge object), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Add a handling charge rule
     * 
     * @param body Handling Charge Rule
     */
    public addHandlingChargeRuleWithHttpInfo(body: models.HandlingChargeRule, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/handlingcharge/rule`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'body' is not null or undefined
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling addHandlingChargeRule.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: body == null ? '' : JSON.stringify(body), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * DELETE a handling charge config
     * 
     * @param configId handlingcharge_id
     */
    public deleteHandlingChargeWithHttpInfo(configId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/handlingcharge/config/${configId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'configId' is not null or undefined
        if (configId === null || configId === undefined) {
            throw new Error('Required parameter configId was null or undefined when calling deleteHandlingCharge.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Delete a handling charge rule
     * 
     * @param ruleId Handling Charge ID
     */
    public deleteHandlingChargeRuleWithHttpInfo(ruleId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/handlingcharge/rule/${ruleId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'ruleId' is not null or undefined
        if (ruleId === null || ruleId === undefined) {
            throw new Error('Required parameter ruleId was null or undefined when calling deleteHandlingChargeRule.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get a handling charge config
     * 
     * @param configId handlingcharge_id
     */
    public getHandlingChargeWithHttpInfo(configId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/handlingcharge/config/${configId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'configId' is not null or undefined
        if (configId === null || configId === undefined) {
            throw new Error('Required parameter configId was null or undefined when calling getHandlingCharge.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Add a handling charge rule
     * 
     * @param ruleId Handling Charge ID
     */
    public getHandlingChargeRuleWithHttpInfo(ruleId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/handlingcharge/rule/${ruleId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'ruleId' is not null or undefined
        if (ruleId === null || ruleId === undefined) {
            throw new Error('Required parameter ruleId was null or undefined when calling getHandlingChargeRule.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get a list of all handling charges
     * 
     * @param namespace 
     */
    public getListHandlingChargeWithHttpInfo(namespace: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/handlingcharge/config`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'namespace' is not null or undefined
        if (namespace === null || namespace === undefined) {
            throw new Error('Required parameter namespace was null or undefined when calling getListHandlingCharge.');
        }
        if (namespace !== undefined) {
            queryParameters.set('namespace', <any>namespace);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get a list of all handling charge rules
     * 
     * @param namespace 
     */
    public getListHandlingChargeRulesWithHttpInfo(namespace: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/handlingcharge/rule`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'namespace' is not null or undefined
        if (namespace === null || namespace === undefined) {
            throw new Error('Required parameter namespace was null or undefined when calling getListHandlingChargeRules.');
        }
        if (namespace !== undefined) {
            queryParameters.set('namespace', <any>namespace);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Add a new handling charge configuration
     * 
     * @param handling charge object handling charge
     * @param configId 
     */
    public updateHandlingChargeWithHttpInfo(handling charge object: models.HandlingCharge, configId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/handlingcharge/config/${configId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'handling charge object' is not null or undefined
        if (handling charge object === null || handling charge object === undefined) {
            throw new Error('Required parameter handling charge object was null or undefined when calling updateHandlingCharge.');
        }
        // verify required parameter 'configId' is not null or undefined
        if (configId === null || configId === undefined) {
            throw new Error('Required parameter configId was null or undefined when calling updateHandlingCharge.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: handling charge object == null ? '' : JSON.stringify(handling charge object), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Add a handling charge rule
     * 
     * @param ruleId Handling Charge ID
     * @param body Handling Charge Rule
     */
    public updateHandlingChargeRuleWithHttpInfo(ruleId: string, body: models.HandlingChargeRule, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/handlingcharge/rule/${ruleId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'ruleId' is not null or undefined
        if (ruleId === null || ruleId === undefined) {
            throw new Error('Required parameter ruleId was null or undefined when calling updateHandlingChargeRule.');
        }
        // verify required parameter 'body' is not null or undefined
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling updateHandlingChargeRule.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: body == null ? '' : JSON.stringify(body), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
