/**
 * STAMP API
 * Neopost STAMP API. This API provides Shipping Tracking Accounting and Mailing functionalities.
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH }                                         from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class ShipperConfigurationApi {
    protected basePath = 'https://api-dev.neopost.com/stamp/v1';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * 
     * Extends object by coping non-existing properties.
     * @param objA object to be extended
     * @param objB source object
     */
    private extendObj<T1,T2>(objA: T1, objB: T2) {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                (objA as any)[key] = (objB as any)[key];
            }
        }
        return <T1&T2>objA;
    }

    /**
     * Add a new shipper configuration
     * 
     * @param shipper account object shipperaccount
     */
    public addShipperAccount(shipper account object: models.ShipperAccount, extraHttpRequestParams?: any): Observable<{}> {
        return this.addShipperAccountWithHttpInfo(shipper account object, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Delete a shipper configuration
     * 
     * @param shipperID shipper id to be deleted
     */
    public deleteShipper(shipperID: string, extraHttpRequestParams?: any): Observable<models.Status> {
        return this.deleteShipperWithHttpInfo(shipperID, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get list of shipper account configurations
     * 
     * @param alias The alias
     * @param length Max number of records to return
     * @param start First record to start
     * @param orderBy name of field to sort by
     * @param orderAsc Ascending order or Descending order
     */
    public getListShipperAccountNamespace(alias?: string, length?: number, start?: number, orderBy?: Array<string>, orderAsc?: boolean, extraHttpRequestParams?: any): Observable<models.ShipperList> {
        return this.getListShipperAccountNamespaceWithHttpInfo(alias, length, start, orderBy, orderAsc, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Get a shipper configuration
     * 
     * @param shipperID shipper id to be get
     */
    public getShipper(shipperID: string, extraHttpRequestParams?: any): Observable<models.ShipperAccount> {
        return this.getShipperWithHttpInfo(shipperID, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * update a shipper configuration
     * 
     * @param shipper object shipper
     * @param shipperID shipper id to be get
     */
    public updateShipper(shipper object: models.ShipperAccount, shipperID: string, extraHttpRequestParams?: any): Observable<models.Status> {
        return this.updateShipperWithHttpInfo(shipper object, shipperID, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * Add a new shipper configuration
     * 
     * @param shipper account object shipperaccount
     */
    public addShipperAccountWithHttpInfo(shipper account object: models.ShipperAccount, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/shipper`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'shipper account object' is not null or undefined
        if (shipper account object === null || shipper account object === undefined) {
            throw new Error('Required parameter shipper account object was null or undefined when calling addShipperAccount.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: shipper account object == null ? '' : JSON.stringify(shipper account object), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Delete a shipper configuration
     * 
     * @param shipperID shipper id to be deleted
     */
    public deleteShipperWithHttpInfo(shipperID: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/shipper/${shipperID}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'shipperID' is not null or undefined
        if (shipperID === null || shipperID === undefined) {
            throw new Error('Required parameter shipperID was null or undefined when calling deleteShipper.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get list of shipper account configurations
     * 
     * @param alias The alias
     * @param length Max number of records to return
     * @param start First record to start
     * @param orderBy name of field to sort by
     * @param orderAsc Ascending order or Descending order
     */
    public getListShipperAccountNamespaceWithHttpInfo(alias?: string, length?: number, start?: number, orderBy?: Array<string>, orderAsc?: boolean, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/shipper`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (alias !== undefined) {
            queryParameters.set('alias', <any>alias);
        }
        if (length !== undefined) {
            queryParameters.set('length', <any>length);
        }
        if (start !== undefined) {
            queryParameters.set('start', <any>start);
        }
        if (orderBy !== undefined) {
            queryParameters.set('orderBy', <any>orderBy);
        }
        if (orderAsc !== undefined) {
            queryParameters.set('orderAsc', <any>orderAsc);
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Get a shipper configuration
     * 
     * @param shipperID shipper id to be get
     */
    public getShipperWithHttpInfo(shipperID: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/shipper/${shipperID}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'shipperID' is not null or undefined
        if (shipperID === null || shipperID === undefined) {
            throw new Error('Required parameter shipperID was null or undefined when calling getShipper.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'text/plain'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            



        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * update a shipper configuration
     * 
     * @param shipper object shipper
     * @param shipperID shipper id to be get
     */
    public updateShipperWithHttpInfo(shipper object: models.ShipperAccount, shipperID: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/shipper/${shipperID}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'shipper object' is not null or undefined
        if (shipper object === null || shipper object === undefined) {
            throw new Error('Required parameter shipper object was null or undefined when calling updateShipper.');
        }
        // verify required parameter 'shipperID' is not null or undefined
        if (shipperID === null || shipperID === undefined) {
            throw new Error('Required parameter shipperID was null or undefined when calling updateShipper.');
        }


        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];
        
        // authentication (jwtAuth) required
        // oauth required
        if (this.configuration.accessToken)
        {
            let accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers.set('Authorization', 'Bearer ' + accessToken);
        }
            

        headers.set('Content-Type', 'application/json');


        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: shipper object == null ? '' : JSON.stringify(shipper object), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });
        
        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
